#ifndef PLAY_3DSOUND_H
#define PLAY_3DSOUND_H

#include <objbase.h>
//#include <initguid.h>
#include <commctrl.h>
#include <commdlg.h>
#include <mmreg.h>
#include <dsound.h>
//#include "resource.h"
#include "WavRead.h"


extern HRESULT InitDirectSound( HWND hDlg );
extern HRESULT FreeDirectSound();
extern VOID SetParameters( FLOAT fDopplerFactor, FLOAT fRolloffFactor);

//extern VOID LoadWaveFile( HWND hDlg, TCHAR* strFileName );
//extern HRESULT PlayBuffer( BOOL bLooped );
//extern VOID StopBuffer();

class MYSOUND {
public:
	MYSOUND(TCHAR* strFileName);
	~MYSOUND();
	//VOID LoadWaveFile( HWND hDlg, TCHAR* strFileName );
	HRESULT PlaySound( BOOL bLooped=FALSE );
	VOID StopBuffer(); 
	VOID SetParameters(FLOAT fMinDistance,   FLOAT fMaxDistance );
	VOID SetObjectProperties( D3DVECTOR* pvPosition, D3DVECTOR* pvVelocity );
	HRESULT RestoreBuffer(); 

private:
	CWaveSoundRead*         pWaveSoundRead;
	LPDIRECTSOUNDBUFFER     pDSBuffer;   // Secondary sound buffer
	LPDIRECTSOUND3DBUFFER   pDS3DBuffer     ;   // 3D sound buffer
	DWORD                   dwBufferBytes;
	//LPDIRECTSOUND3DLISTENER pDSListener     = NULL;   // 3D listener object
	//DS3DLISTENER            dsListenerParams;         // Listener properties
	DS3DBUFFER              dsBufferParams;           // 3D buffer properties

	HRESULT CreateStaticBuffer(TCHAR* strFileName );
	HRESULT FillBuffer();
};


#endif // !defined(PLAY_3DSOUND_H)
